unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Button2: TButton;
    Button3: TButton;
    Image1: TImage;
    Button4: TButton;
    Button5: TButton;
    Edit2: TEdit;
    Button6: TButton;
    Edit3: TEdit;
    Button7: TButton;
    Edit4: TEdit;
    Button8: TButton;
    Button9: TButton;
    Edit5: TEdit;
    Button10: TButton;
    Button11: TButton;
    Edit6: TEdit;
    Edit7: TEdit;
    Button12: TButton;
    Edit8: TEdit;
    Button13: TButton;
    Edit9: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

  noeud = class
  private
     entier : integer ;
     gauche,droite : noeud ;
     constructor create(nb : integer) ;
     destructor  destroy ;
     procedure   ajouter(nb : integer) ;
     procedure   afficher(x,y,l : integer) ;
     function    egal_a(noeud2 : noeud) : boolean ;
  end ;

  arbre = class
  private
     tete,courant : noeud ;
  public
     constructor create(nb : integer) ;
     destructor  destroy ;
     procedure   ajouter(nb : integer) ;
     procedure   afficher(x,y,l : integer) ;
     function    compter_noeuds(posit : noeud) : integer ;
     function    compter_niveaux(posit : noeud) : integer ;
     function    egal_a(arbre2 : arbre) : boolean ;
  end ;

var
  Form1: TForm1;
  arbre_nb : arbre ;

implementation

{$R *.DFM}

constructor noeud.create(nb : integer) ;
begin
entier:=nb ;
gauche:=nil ;droite:=nil ;
end ;

destructor noeud.destroy ;
begin
if gauche<>nil then gauche.destroy ;
if droite<>nil then droite.destroy ;
end ;

procedure noeud.ajouter(nb : integer) ;
begin
if nb>=entier then
   if droite<>nil then
      droite.ajouter(nb)
   else
      droite:=noeud.create(nb)
else
   if gauche<>nil then
      gauche.ajouter(nb)
   else
      gauche:=noeud.create(nb) ;
end ;

procedure noeud.afficher(x,y,l : integer) ;
begin
with form1.image1.picture.bitmap.canvas do
   begin
   ellipse(x,y,x+25,y+25) ;
   textOut(x+5,y+5,inttostr(entier)) ;
   if gauche<>nil then
      begin
      moveto(x+3,y+20) ;lineto(x-(l div 2)+10,y+70) ;
      gauche.afficher(x-(l div 2),y+60,l div 2) ;
      end ;
   if droite<>nil then
      begin
      moveto(x+22,y+20) ;lineto(x+(l div 2)+10,y+70) ;
      droite.afficher(x+(l div 2),y+60,l div 2) ;
      end ;
   end ;
end ;

function noeud.egal_a(noeud2 : noeud) : boolean ;
begin
if (self=nil) and (noeud2=nil) then
   egal_a:=true
else
if ((self<>nil) and (noeud2=nil)) or
   ((self=nil) and (noeud2<>nil)) or
   (entier<>noeud2.entier) then
   egal_a:=false
else
   egal_a:=gauche.egal_a(noeud2.gauche) and droite.egal_a(noeud2.droite) ;
end ;

//--------------------------------------
constructor arbre.create(nb : integer) ;
begin
tete:=noeud.create(nb) ;
courant:=tete ;
end ;

destructor arbre.destroy ;
begin
courant:=nil ;
tete.destroy ;
end ;

procedure arbre.ajouter(nb : integer) ;
begin
tete.ajouter(nb) ;
end ;

procedure arbre.afficher(x,y,l : integer) ;
begin
tete.afficher(x,y,l) ;
end ;

function arbre.compter_noeuds(posit : noeud) : integer ;
begin
if posit=nil then compter_noeuds:=0
else
   compter_noeuds:=1+compter_noeuds(posit.gauche)+compter_noeuds(posit.droite) ;
end ;

function arbre.compter_niveaux(posit : noeud) : integer ;
var ng,nd : integer ;
begin
if posit=nil then compter_niveaux:=0
else
   begin
   ng:=1+compter_niveaux(posit.gauche) ;
   nd:=1+compter_niveaux(posit.droite) ;
   if ng>nd then compter_niveaux:=ng else compter_niveaux:=nd ;
   end ;
end ;

function arbre.egal_a(arbre2 : arbre) : boolean ;
begin
if (self=nil) and (arbre2=nil) then egal_a:=true
else
if (self=nil) and (arbre2<>nil) then egal_a:=false
else
if (self<>nil) and (arbre2=nil) then egal_a:=false
else
    egal_a:=tete.egal_a(arbre2.tete) ;
end ;
//----------------------------------------------------------

procedure TForm1.FormCreate(Sender: TObject);
begin
arbre_nb:=nil ;
image1.picture.bitmap:=tbitmap.create ;
with image1.picture.bitmap do
   begin
   width:=609 ;height:=297 ;
   end ;
end;

procedure TForm1.Button1Click(Sender: TObject);  // ajouter nombre
var nb : integer ;
begin
nb:=strtoint(edit1.text) ;
if arbre_nb=nil then arbre_nb:=arbre.create(nb)
   else arbre_nb.ajouter(nb) ;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin  // dessiner l'arbre
if arbre_nb=nil then exit ;
with image1.picture.bitmap.canvas do rectangle(0,0,image1.width,image1.height) ;
arbre_nb.tete.afficher(image1.width div 2 , 10 , image1.width div 2) ;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
if arbre_nb<>nil then arbre_nb.destroy ;
close ;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin  // compter noeuds
if arbre_nb=nil then exit ;
edit2.text:=inttostr(arbre_nb.compter_noeuds(arbre_nb.tete)) ;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin  // niveaux de l'arbre
if arbre_nb=nil then exit ;
edit3.text:=inttostr(arbre_nb.compter_niveaux(arbre_nb.tete)) ;
end;

procedure TForm1.Button4Click(Sender: TObject);
var nb_noeuds,nb_niv,p : integer ;
    arbre_eq : arbre ;

   procedure creer_arbre(n : noeud ;niv : integer;var nb_n : integer) ;
   begin
   if nb_n=nb_noeuds then exit ;  // tous les noeuds ncessaires ont t crs
   if niv<nb_niv then
      begin
      n.gauche:=noeud.create(0) ;
      inc(nb_n) ;
      creer_arbre(n.gauche,niv+1,nb_n) ;
      n.droite:=noeud.create(0) ;
      inc(nb_n) ;
      creer_arbre(n.droite,niv+1,nb_n) ;
      end ;
   end ;

   procedure remplir(n : noeud ;valeur,posit,nb_n : integer) ;
   var n1 : integer ;
   begin
   if nb_n=1 then
      n.entier:=valeur
   else
      begin
      n1:=1 ;
      while nb_n>n1 do n1:=n1*2 ;
      if posit=(n1 div 2) then
         n.entier:=valeur
      else
      if posit<(n1 div 2) then
         remplir(n.gauche,valeur,posit,arbre_nb.compter_noeuds(n.gauche))
      else
         remplir(n.droite,valeur,posit-(n1 div 2),arbre_nb.compter_noeuds(n.droite)) ;
      end ;
   end ;

   procedure parcourir(n : noeud ;var nb : integer) ;
   begin
   if n=nil then exit ;
   parcourir(n.gauche,nb) ;
   inc(nb) ;remplir(arbre_eq.tete,n.entier,nb,nb_noeuds) ;
   parcourir(n.droite,nb) ;
   end ;
begin  // equilibrer l'arbre
if arbre_nb=nil then exit ;
//------- on va calculer le nombre de niveaux du nouvel arbre
nb_noeuds:=arbre_nb.compter_noeuds(arbre_nb.tete) ;
nb_niv:=1 ;p:=2 ;
while nb_noeuds>p do
   begin                     
   p:=p*2 ;inc(nb_niv) ;
   end ;
//------- on va crer le nouvel arbre
arbre_eq:=arbre.create(0) ;
p:=1 ; // un noeud cr , la tte de l'arbre
creer_arbre(arbre_eq.tete,1,p) ;
//------- recopie des lments
p:=0 ;
parcourir(arbre_nb.tete,p) ;
//-------
arbre_nb.destroy ;
arbre_nb:=arbre_eq ;
end;

procedure TForm1.Button7Click(Sender: TObject);
var p,nb : integer ;
    st : string ;
begin
st:=edit4.text ;
repeat
  p:=pos(';',st) ;
  if p>0 then
     begin
     nb:=strtoint(copy(st,1,p-1)) ;
     if arbre_nb=nil then arbre_nb:=arbre.create(nb)
        else arbre_nb.ajouter(nb) ;
     delete(st,1,p) ;
     end ;
until p=0 ;
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
if arbre_nb=nil then exit ;
arbre_nb.destroy ;
arbre_nb:=nil ;
end;

procedure TForm1.Button9Click(Sender: TObject); //--- affichage prefix
   procedure aff(n : noeud) ;
   begin
   if n=nil then exit ;
   edit5.text:=edit5.text+intToStr(n.entier)+';' ;
   aff(n.gauche) ;
   aff(n.droite) ;
   end ;
begin
aff(arbre_nb.tete) ;
end;

procedure TForm1.Button10Click(Sender: TObject);  //--- affichage infix
   procedure aff(n : noeud) ;
   begin
   if n=nil then exit ;
   aff(n.gauche) ;
   edit6.text:=edit6.text+intToStr(n.entier)+';' ;
   aff(n.droite) ;
   end ;
begin
aff(arbre_nb.tete) ;
end;

procedure TForm1.Button11Click(Sender: TObject);  //--- affichage postfix
   procedure aff(n : noeud) ;
   begin
   if n=nil then exit ;
   aff(n.gauche) ;
   aff(n.droite) ;
   edit7.text:=edit7.text+intToStr(n.entier)+';' ;
   end ;
begin
aff(arbre_nb.tete) ;
end;



procedure TForm1.Button12Click(Sender: TObject);
var p,nb : integer ;
    st : string ;
    arbre2 : arbre ;
begin  // test si gaux
st:=edit4.text ;
arbre2:=nil ;
repeat
  p:=pos(';',st) ;
  if p>0 then
     begin
     nb:=strtoint(copy(st,1,p-1)) ;
     if arbre2=nil then arbre2:=arbre.create(nb)
        else arbre2.ajouter(nb) ;
     delete(st,1,p) ;
     end ;
until p=0 ;
if arbre_nb.egal_a(arbre2) then edit8.text:='true'
   else edit8.text:='false' ;
arbre2.destroy ;
end;

procedure TForm1.Button13Click(Sender: TObject);
var i,j : integer ;
   procedure aff(n : noeud ;niveau_courant,niveau : integer) ;
   begin
   if n=nil then exit ;
   if niveau=niveau_courant then
      edit9.text:=edit9.text+intToStr(n.entier)+';'
   else
      begin
      aff(n.gauche,niveau_courant+1,niveau) ;
      aff(n.droite,niveau_courant+1,niveau) ;
      end ;
   end ;
begin     // affichage largeur
edit9.text:='' ;
if arbre_nb=nil then exit ;
j:=arbre_nb.compter_niveaux(arbre_nb.tete) ;
for i:=1 to j do
    aff(arbre_nb.tete,1,i) ;
end;

end.
